unit TestUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, stelmap, StdCtrls, GIFImg;

const
  MoscowLAT = -55.75578;
  MoscowLON = 37.615149;

type
  TForm2 = class(TForm)
    StelMap1: TStelMap;
    Panel1: TPanel;
    Offline: TCheckBox;
    ShowSet: TCheckBox;
    LabelLoadMap: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure FormResize(Sender: TObject);
    procedure OfflineClick(Sender: TObject);
    procedure ShowSetClick(Sender: TObject);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure StelMap1BeginMapLoad(count: Integer);
    procedure StelMap1EndMapLoad;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure StelMap1MapMouseMove(LAT, LON: Double; x, y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  GlobalLAT, GlobalLON : Double;

implementation

{$R *.dfm}

procedure TForm2.Button1Click(Sender: TObject);
var
  Car : TBMPObject;
begin
  Car := StelMap1.Layers(0).AddBitmap(MoscowLAT, MoscowLON, 'Car', True, 0, 0);
  Car.BitMap.LoadFromFile('car.bmp');
  StelMap1.ReDraw;
  if (StelMap1.Layers(0).BitMapList.Count > 0) and (StelMap1.Layers(0).ShapeList.Count > 0) then
    Button4.Enabled := TRUE;
  Button1.Enabled := FALSE;
end;

procedure TForm2.Button2Click(Sender: TObject);
var
  Points : TArrayLatLon;
begin
  SetLength(Points, 6);
  Points[0].LAT := MoscowLAT; Points[0].LON := MoscowLON;
  Points[1].LAT := MoscowLAT-1; Points[1].LON := MoscowLON;
  Points[2].LAT := MoscowLAT; Points[2].LON := MoscowLON-1;
  Points[3].LAT := MoscowLAT; Points[3].LON := MoscowLON+1;
  Points[4].LAT := MoscowLAT+1; Points[4].LON := MoscowLON;
  Points[5].LAT := MoscowLAT; Points[5].LON := MoscowLON;
  StelMap1.Layers(0).AddShape(Points, 2, clRed, psSolid);
  StelMap1.ReDraw;
  if (StelMap1.Layers(0).BitMapList.Count > 0) and (StelMap1.Layers(0).ShapeList.Count > 0) then
    Button4.Enabled := TRUE;
  Button2.Enabled := FALSE;
end;

procedure TForm2.Button3Click(Sender: TObject);
begin
  StelMap1.Layers(0).BitMapList.Clear;
  StelMap1.Layers(0).ShapeList.Clear;
  StelMap1.ReDraw;
  Button4.Enabled := FALSE;
  Button1.Enabled := TRUE;
  Button2.Enabled := TRUE;
end;

procedure TForm2.Button4Click(Sender: TObject);
var
  Car : TBMPObject;
begin
  Car := StelMap1.Layers(0).BitMapList[0];
  Car.LatLon.LAT := MoscowLAT-1; Car.LatLon.LON := MoscowLON;
  StelMap1.ReDraw;
  Application.ProcessMessages;
  Sleep(1000);

  Car.LatLon.LAT := MoscowLAT; Car.LatLon.LON := MoscowLON-1;
  StelMap1.ReDraw;
  Application.ProcessMessages;
  Sleep(1000);

  Car.LatLon.LAT := MoscowLAT; Car.LatLon.LON := MoscowLON+1;
  StelMap1.ReDraw;
  Application.ProcessMessages;
  Sleep(1000);

  Car.LatLon.LAT := MoscowLAT+1; Car.LatLon.LON := MoscowLON;
  StelMap1.ReDraw;
  Application.ProcessMessages;
  Sleep(1000);

  Car.LatLon.LAT := MoscowLAT; Car.LatLon.LON := MoscowLON;
  StelMap1.ReDraw;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  StelMap1.AddLayer;
end;

procedure TForm2.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  StelMap1.ZoomInPos(GlobalLAT, GlobalLON);
  Handled := TRUE;
end;

procedure TForm2.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  StelMap1.ZoomOutPos(GlobalLAT, GlobalLON);
  Handled := TRUE;
end;

procedure TForm2.FormResize(Sender: TObject);
begin
  StelMap1.MapResize;
  StelMap1.Prepare;
  StelMap1.LoadMap();
  StelMap1.ReDraw;
end;

procedure TForm2.OfflineClick(Sender: TObject);
begin
  StelMap1.Offline := Offline.Checked;
end;

procedure TForm2.ShowSetClick(Sender: TObject);
begin
  StelMap1.ShowSet := ShowSet.Checked;
end;

procedure TForm2.StelMap1BeginMapLoad(count: Integer);
begin
  LabelLoadMap.Visible := True;
  LabelLoadMap.Refresh;
end;

procedure TForm2.StelMap1EndMapLoad;
begin
  LabelLoadMap.Visible := False;
  LabelLoadMap.Refresh;
end;

procedure TForm2.StelMap1MapMouseMove(LAT, LON: Double; x, y: Integer);
begin
  GlobalLAT := LAT;
  GlobalLON := LON;
end;

end.
